//import './jquery.plugin.min.js';
//import './jquery.countdown.min.js';
import ClipboardJS from './clipboard.min.js';
import './src/facebook.js';
import './slick.min.js';

(function($){

	function sgUpdateEntries( entries, giveawayBox ) {
		var giveawayBox = giveawayBox || false;

		if ( ! giveawayBox ) {
			giveawayBox = $('.giveasap-box');
		}

		giveawayBox.find('.giveasap-entries strong').html( entries );
	}

	if ( $('.sg-giveaway-prizes-slider').length ) {
        $(".sg-giveaway-prizes-slider").slick({
            // normal options...
            infinite: true,
            slidesToShow: 1,
            slidesToScroll: 1,
            arrows: false,
            dots: true
        });
	}

	$( document ).on( 'click', '.sg-extra-action-title, .sg-extra-action-close', function( e ){
		e.preventDefault();
		var actionTitle = $(this).parents('.sg-extra-action').find('.sg-extra-action-title'),
			expanded    = actionTitle.attr('aria-expanded') === 'true';

        actionTitle.attr('aria-expanded', !expanded);

		$(this).parents('.sg-extra-action').toggleClass('expanded');
	});

	$( document ).on( 'submit', '.sg-extra-action form', function(e){
        var $this = $(this),
            form  = $this,
            data  = $(this).serialize(),
			processData = true,
			contentType = 'application/x-www-form-urlencoded',
			ajaxData = {
                action: 'sg_extra_action_complete',
                nonce: sg.nonce,
                data: data,
            };

        if ( form.find('input[type=file]').length > 0 ) {
        	if ( window.FormData ) {
                ajaxData = new FormData(form[0]);
        		ajaxData.append( 'action', 'sg_extra_action_complete' );
                ajaxData.append( 'nonce', sg.nonce );
                ajaxData.append( 'data', data );
                processData = false;
                contentType = false;
			}
		}

        form.addClass('sg-loading');

        $.ajax({
            url: sg.ajaxurl,
			method: 'POST',
			contentType: contentType,
			processData: processData,
            data: ajaxData,
            success: function( resp ) {
                if ( resp.success ) {
                	var html = resp.data.complete_mark || '',
						entries = resp.data.entries || false,
						action_html = resp.data.html || false;

                	if ( html ) {
                		var title = form.parent().find('.sg-extra-action-title');
                		title.find('.sg-extra-action-entries').remove();
                		title.append( html );
					}

					if ( action_html ) {
                		form.find('.sg-extra-action-form-body').html( action_html );
					}

					if ( entries ) {
                		var gBox = form.parents('.giveasap-box');

                		if ( gBox.length === 0 ) {
                			gBox = form.parents('.giveasap_box');
						}
                        sgUpdateEntries( entries, gBox );
					}

					$this.find('button[name=sg_extra_action_submit]').remove();
                } else {
                    alert( resp.data );
                }
            },
			complete: function() {
            	form.removeClass('sg-loading');
			}
        });

		return false;
	});

	$( document ).on( 'click', '.sg_extra_action_button[data-check-action]', function(e){
		var $this = $(this),
			form  = $this.parents('form'),
			data  = form.serialize();

        form.addClass('sg-loading');
		$.ajax({
            url: sg.ajaxurl,
			data: {
            	action: 'sg_extra_action_check',
				nonce: sg.nonce,
				data: data
			},
			success: function( resp ) {
            	if ( resp.success ) {
					if ( typeof resp.data !== 'undefined' && typeof resp.data.redirect !== 'undefined' && resp.data.redirect ) {
						window.location.href = resp.data.redirect;
					} else {
                        form.find('[name=sg_extra_action_submit]').removeAttr('disabled');
					}
				} else {
            		alert( resp.data );
				}
			},
            complete: function() {
                form.removeClass('sg-loading');
            }
		});
	});

	// We are ready!
	$(function(){
        var $countdown = $("#countdown"),
            $countdowns = $(".giveasap_countdown");

        if( $countdown.length ) {
            var $timestamp = $countdown.attr("data-end");
            var $timezone = $countdown.attr("data-timezone");
            $countdown.countdown({
                until: new Date($timestamp * 1000), format: 'dHMS'});
        }

        if( $countdowns.length ) {
            $countdowns.each(function(){
                var $timestamp = $(this).attr("data-end");
                var $timezone = $(this).attr("data-timezone");
                $(this).countdown({
                    until: new Date($timestamp * 1000), format: 'dHMS'});
            });
        }

        if( $('.giveasap.template3 .giveasap_box.step-1').length > 0 ) {
            var height = $('.giveasap_aside').outerHeight(true) + 100;

            $('.giveasap_box').css( 'margin-bottom', height + 'px' );
        }
	});


 	$("#giveasap_show_rules").on( 'click', function(){
 		$(".giveasap_rules_extended").toggleClass("active");
 	});

 	$( "#giveasap_request_link" ).on( 'click', function(e){
 		$(this).parents('form').addClass('hidden');
 		$('#giveasap_request_link_form').removeClass('hidden'); 
 	});

 	$('.sg-toggle').on( 'click', function (e) {
		e.preventDefault();
		var $this   = $(this),
			$target = $this.attr('data-target'),
			$class  = $this.attr('data-class'),
			$text   = $this.attr('data-text');

		$( $target ).toggleClass( $class );
		if ( $text ) {
			var old_text = $this.text();
			$this.attr('data-text', old_text );
			$this.html( $text );
		}
    });

	$( document ).on( 'click', '.giveasap_sharing .sharing_method a', function(e){
        var href = $(this).attr('href'),
			popup = $(this).attr('data-popup');

        $( document.body ).triggerHandler( 'giveasap_sharing_method_clicked', [ $(this) ] );

        if ( typeof popup !== 'undefined' && popup === '1' ) {
            e.preventDefault();

            popupWindow = window.open(
                href,
                'popUpWindow',
                'height=300,width=400,left=50,top=50,resizable=yes,scrollbars=yes,toolbar=yes,menubar=no,location=no,directories=no,status=yes');
        }
	});

	if ( $( '.giveasap_link' ).length && ClipboardJS.isSupported() ) {
		var val = $('.giveasap_link input').val();
		$('.giveasap_link').append( '<button data-clipboard-text="' + val + '" class="sg-btn-copy" type="button"><span class="fal fa-copy"></span><span class="sg-btn-copy-text">Copy</span></button>' );
        var clipboard =new ClipboardJS('.sg-btn-copy');
        clipboard.on('success', function(e) {
        	var icon =  $('.sg-btn-copy .fal');
            icon.removeClass('fa-copy').addClass('fa-check');
            setTimeout(function(){
                icon.removeClass('fa-check').addClass('fa-copy');
			}, 2000);
        });

    }

})(jQuery);